<?php
#====================================================================================================
# $Id: ke_init.php,v 1.10 2006/10/14 09:49:44 matsui Exp $
# ʏ
# 2005/12/15 matsui@ke-tai.org
# 2010/03/14 ΂ go_west@jmail.plala.or.jp
#            ȃoOtBNX
#====================================================================================================
# @\F
# ʏNX
#====================================================================================================
# CF
# 2006/08/31 tB^ύXAꕔtB^̒ǉ̎dύXioutputfilter@@prefilterjApJiCqǉ
# 
#====================================================================================================

/**
 * ʏNX
 * @package		KEMP
 */
class KeInit {
	/**
	 * RXgN^
	 * @param	class	$ke			CNX
	 */
	function KeInit($ke) {
		// ÓIf[^`(z)̓ǂݍ
		$ke->def =& new KeArrDefine();
		
		// PEARCN[hpX̐ݒ
		if (defined('KE_PEAR_DIR')) {
			$path = ini_get('include_path');
			if (preg_match('/;/', $path)) {
				ini_set('include_path', KE_PEAR_DIR . ';' . $path);
			} else {
				ini_set('include_path', KE_PEAR_DIR . ':' . $path);
			}
		} else {
			define('KE_PEAR_DIR', '');
		}
		
		// mb*̕R[hZbg
		mb_internal_encoding(KE_ENCODING);
		mb_regex_encoding(KE_ENCODING);
		
		// vOID̎擾
		$ke->pg_id = $this->getPgId();
		
		// O֘Ȁ
		$ke->logger =& $this->initLog();
		
		// G[̗}~
		$this->errInit($ke);
		
		// [̎擾
		$ke->agent =& $this->getClientInfo();
		
		// HDMLp@̓T|[gO
		if ($ke->agent->isEZweb()) {
			if (!$ke->agent->isXHTMLCompliant()) {
				$ke->error(KE_ERR_MSG_MODEL);
			}
		}
		
		// [擾gNX̏
		$ke->agent_ext =& $this->initClientInfoExt($ke->agent);
		
		// LAރR[h̎擾
		$ke->carrier_cd =& $this->getCarrierCode($ke->agent);
		
		// ZbV̏
		$this->initSession($ke);
		
		// tB^̏
		$ke->filter =& $this->initFilter($ke);
		
		// ev[gVXȅ
		$ke->tpl =& $this->initTpl($ke->filter, $ke->agent);
		
		// KEMPŒev[gϐ̃Zbg
		$this->setTplVar($ke);
	}
	
	
	/**
	 * vOID̎擾
	 * @return	string		vOID
	 */
	function getPgId() {
		$filename = '';
		$arr = explode('/', $_SERVER['SCRIPT_NAME']);
		for ($i = 0; $i < substr_count(BASEPATH, '..'); $i++) {
			$filename = array_pop($arr) . '/' . $filename;
		}
		$pg_id = substr($filename, 0, strrpos($filename, '.'));			// gq菜
		
		return $pg_id;
	}
	
	
	/**
	 * LAރR[h擾
	 * @param	class	$agent		Net_UserAgent_MobileNX
	 * @return	string				LAރR[h
	 */
	function getCarrierCode($agent) {
		// ʕ擾
		$display = $agent->getDisplay();
		$width = $display->getWidth();
		
		// LAAVGA
		if ($agent->isDoCoMo()) {
			if (KE_TPL_VGA_BODER > $width) {
				$carrier = KE_TPL_I01;
			} else {
				$carrier = KE_TPL_I02;
			}
		} elseif ($agent->isVodafone()) {
			if (KE_TPL_VGA_BODER > $width) {
				$carrier = KE_TPL_V01;
			} else {
				$carrier = KE_TPL_V02;
			}
		} elseif ($agent->isEZweb()) {
			if (KE_TPL_VGA_BODER > $width) {
				$carrier = KE_TPL_E01;
			} else {
				$carrier = KE_TPL_E02;
			}
		} else {
			$carrier = KE_TPL_PC;
		}
		
		return $carrier;
	}
	
	
	/**
	 * G[}~̐ݒ
	 * @param	$ke			CNX
	 */
	function errInit($ke) {
		// G[nhNXǂݍ
		require_once(KE_LIB_DIR . '/ke_err_handler.php');
		$eh =& new KeErrHandler($ke);
		
		// PHPG[nh̐ݒ
		set_error_handler(array(&$eh, 'phpErrHandler'));
	}
	
	
	/**
	 * O֘Ȁ
	 * @return	class		PEARONX
	 */
	function initLog() {
		// PEARONX̐
		require_once('Log.php');
		//define('KE_LOG_LEVEL', PEAR_LOG_DEBUG);
		$logger =& Log::singleton(KE_LOG_TYPE, KE_LOG_FILE, KE_LOG_IDENT);	// NX
		$logger->setMask(Log::UPTO(constant('PEAR_LOG_DEBUG')));				// Ox̐ݒ
		
		return $logger;
	}
	
	
	/**
	 * [̎擾
	 * @return	class		Net_UserAgent_MobileNX
	 */
	function getClientInfo() {
		// PEARNet_UserAgent_Mobile𗘗pĒ[擾
		require_once('Net/UserAgent/Mobile.php');
		$agent = Net_UserAgent_Mobile::factory();
		
		return $agent;
	}
	
	
	/**
	 * [擾p֐Q̏
	 * @param	class	$agent		Net_UserAgent_MobileNX
	 * @return	class				Net_UserAgent_MobileNXiƎgj
	 */
	function initClientInfoExt($agent) {
		// Net_UserAgent_Mobile̓ƎgNXǂݍ
		require_once(KE_LIB_DIR . '/ke_Net_UserAgent_Mobile_ext.php');
		$agent_ext =& new KeNetUserAgentMobileExt($agent);
		
		return $agent_ext;
	}
	
	
	/**
	 * ZbV̏
	 * @param	class	$ke			CNX
	 */
	function initSession($ke) {
		// ZbV̏s
		session_start();
		
		// ZbVlo
		$ke->referer = $_SESSION['KE_CURRENT_PAGE'];		// Oɂy[W
		$_SESSION['KE_CURRENT_PAGE'] = $ke->pg_id;			// ݂̃y[W
		
		// SSL<>SSLŃZbVϐێp
		if (true != $_SESSION['KE_SESSION_CHECK_FLG']) {
			$_SESSION['KE_SESSION_CHECK_FLG'] = true;
		}
		if (in_array('ke_snm', $_REQUEST) && '' != $_REQUEST['ke_snm']
			&& in_array('ke_sid', $_REQUEST) && '' != $_REQUEST['ke_sid']) {
			$_SESSION['KE_SESSION_NAME'] = $_REQUEST['ke_snm'];
			$_SESSION['KE_SESSION_ID'] = $_REQUEST['ke_sid'];
		}
		$this->ssl_exchange = sprintf('ke_snm=%s&ke_sid=%s', session_name(), session_id());
		if (in_array('KE_SESSION_NAME', $_SESSION) && isset($_SESSION['KE_SESSION_ID'])) {
			$this->ssl_exchange = sprintf('%s=%s&%s', $_SESSION['KE_SESSION_NAME'], $_SESSION['KE_SESSION_ID'], $this->ssl_exchange);
		}
	}
	
	
	/**
	 * tB^̏
	 * @param	class	$ke			CNX
	 * @return	class	$filter		tB^NX
	 */
	function initFilter($ke) {
		// tB^`
		require_once(KE_LIB_DIR . '/ke_tpl_filter.php');
		$filter =& new KeTplFilter($ke);
		
		return $filter;
	}
	
	
	/**
	 * ev[gVXȅ
	 * @param	class	$filter		tB^NX
	 * @param	class	$agent		Net_UserAgent_MobileNX
	 * @return	class				SmartyNX
	 */
	function initTpl($filter, $agent) {
		// Smarty̏s
		require_once(KE_SMARTY_DIR . '/' . KE_SMARTY_CLASS);
		$smarty =& new Smarty;
		$smarty->caching = FALSE;									// LbVl̓It
		$smarty->left_delimiter = KE_SMARTY_DELIMITER_LEFT;
		$smarty->right_delimiter = KE_SMARTY_DELIMITER_RIGHT;
		$smarty->compile_dir = KE_SMARTY_COMPILE_DIR;
		$smarty->config_dir = KE_SMARTY_CONFIG_DIR;
		$smarty->cache_dir = KE_SMARTY_CACHE_DIR;
		$smarty->template_dir = KE_TPL_DIR;
		
		// ftHgCq̐ݒ
		$smarty->default_modifiers = array();
		
		if (KE_KANA_CONV) {
			// o͂͑SĔpJiɕϊ
			array_push($smarty->default_modifiers, 'hankaku');
		}
		
		if (KE_SMARTY_ESCAPE_ALL) {
			// o͂͑SăGXP[v
			array_push($smarty->default_modifiers, 'escape:"html"');
		}
		
		// 摜tB^i摜\̂ߕK{j
		$smarty->register_outputfilter(array(&$filter, 'imageFilter'));
		
		// A^OtB^
		if (KE_ATAG_CONV AND TRUE === KE_TPL_VIEWER_FLG) {
			$smarty->register_outputfilter(array(&$filter, 'atagFilter'));
		}
		
		// ̓[htB^
		if (KE_HTML_ISTYLE_CONV) {
			$smarty->register_outputfilter(array(&$filter, 'htmlIstyleFilter'));
		}
		
		// GSJISQƃtB^iĜ̕ߕK{j
		$smarty->register_prefilter(array(&$filter, 'emojiDecordFilter'));
		
		// SmartySJIS𐳏Ɏg߂̃tB^
		$smarty->register_prefilter(array(&$filter, 'convert_encoding_to_eucjp'));
		$smarty->register_postfilter(array(&$filter, 'convert_encoding_to_sjis'));
		
		// pJitB^
		if (KE_KANA_CONV) {
			$smarty->register_postfilter(array(&$filter, 'kanaFilter'));
		}
		
		// VodafoneGtB^
		if (KE_EMOJI_CONV_VODA and $agent->isVodafone()) {
			$smarty->register_outputfilter(array(&$filter, 'emojiVodaFilter'));
		}
		
		// GFttB^
		if (KE_EMOJI_COLOR) {
			$smarty->register_outputfilter(array(&$filter, 'emojiColorFilter'));
		}
		
		// QƁSJIStB^
		if (!KE_EMOJI_DECORD) {
			$smarty->register_outputfilter(array(&$filter, 'emojiEncordFilter'));
		}
		
		// tH[^OstB^(EZwebp)
		if (KE_HTML_FORM_CONV) {
			$smarty->register_outputfilter(array(&$filter, 'htmlFormToBrFilter'));
		}
		
		// pCq̒ǉ
		$smarty->register_modifier('hankaku', array(&$filter, 'kanaModifier'));
		
		return $smarty;
	}
	
	
	/**
	 * KEMPŒev[gϐ̃Zbg
	 * @param	class	$ke			CNX
	 */
	function setTplVar($ke) {
		$ke->tpl->assign('KE_CARRIER_CD', $ke->carrier_cd);				// LAރR[h
		$ke->tpl->assign('KE_SSL_EXCHANGE', $this->ssl_exchange);		// SSL<>SSLZbVێp
	}
	
}
?>