<?php
#====================================================================================================
# $Id: ke_err_handler.php,v 1.1.1.1 2006/01/29 07:26:02 matsui Exp $
# G[nhNX
# 2006/01/05 matsui@ke-tai.org
# 2010/03/14 ΂ go_west@jmail.plala.or.jp
#            ȃoOtBNX
#====================================================================================================
# @\F
# G[nh`
#====================================================================================================
# CF
# 
# 
#====================================================================================================

/**
 * G[nhNX
 * @package		KEMP
 */
class KeErrHandler {
	var $ke;				// CNX
	
	/**
	 * RXgN^
	 * @param	class	$ke			CNX
	 */
	function KeErrHandler($ke) {
		$this->ke =& $ke;
	}
	
	
	/**
	 * PHPG[nh
	 * @param	int		$errno			G[x
	 * @param	string	$errstr			G[bZ[W
	 * @param	string	$errfile		G[t@C
	 * @param	int		$errline		G[s
	 * @param	arr		$errcontext		G[ReLXg
	 */
	function phpErrHandler($errno, $errstr, $errfile, $errline, $errcontext) {
		// PHPG[̏`
		if ($errno != E_USER_NOTICE && $errno != E_NOTICE && $errno != E_STRICT) {
			// Oɏo
			$str = sprintf('PHP Error. Level=%s, file=%s, line=%s, msg=%s', $errno, $errfile, $errline, $errstr);
			$this->ke->putLog($str, PEAR_LOG_ALERT);
			
			// G[̕\
			if (KE_ERR_DISPLAY) {
				switch ($errno) {
					case E_ERROR:
						$errlevel = E_USER_ERROR;
						break;
					case E_WARNING:
						$errlevel = E_USER_WARNING;
						break;
					default:
						$errlevel = E_USER_NOTICE;
				}
				restore_error_handler();
				trigger_error($errstr, $errlevel);
			}
			
			// [őM
			if (KE_ERR_MAIL AND defined('KE_ERR_MAIL_TO')) {
				$addheader = '';
				$subject = '';
				$msg = '';
				if (defined('KE_ERR_MAIL_FROM')) {
					$addheader = sprintf('From: %s', KE_ERR_MAIL_FROM);
				}
				if (defined('KE_ERR_MAIL_SUBJECT')) {
					$subject = KE_ERR_MAIL_SUBJECT;
				}
				if (defined('KE_ERR_MAIL_MSG')) {
					$msg = KE_ERR_MAIL_MSG;
				}
				$body = sprintf("%s\nLevel=%s\nfile=%s\nline=%s\nmsg=%s", $msg, $errno, $errfile, $errline, $errstr);
				mb_send_mail(KE_ERR_MAIL_TO, $subject, $body, $addheader);
			}
			
			// G[ʂo
			$this->ke->error(KE_ERR_MSG_COMMON);
		}
	}
	
}

?>